/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Customer Management, Payment Management and Account Management related APIs.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: orbipay.checkout@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(['superagent', 'querystring', 'crypto', 'path', 'fs','properties-reader', 'Checkout','node-forge'], factory);
    } else if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('superagent'), require('querystring'),require('crypto'),require('path'),require('fs'),require('properties-reader'), require('./Checkout'),require('node-forge'));
    } else {
        // Browser globals (root is window)
        if (!root.OrbipayCheckoutApIs) {
            root.OrbipayCheckoutApIs = {};
        }
        root.OrbipayCheckoutApIs.ApiClient = factory(root.superagent, root.querystring, root.crypto, root.path, root.fs, root.properties-reader, root.Checkout,root.node-forge);
    }
}(this, function(superagent, querystring,crypto,path,fs,properties_reader,Checkout,forge) {
    'use strict';

    /**
     * @module ApiClient
     * @version 1.0.0
     */

    /**
     * Manages low level client-server communications, parameter marshalling, etc. There should not be any need for an
     * application to use this class directly - the *Api and model classes provide the public API for the service. The
     * contents of this file should be regarded as internal but are documented for completeness.
     * @alias module:ApiClient
     * @class
     */
    var exports = function() {

        /**
         * The base URL against which to resolve every API call's (relative) path.
         * @type {String}
         * @default http://192.168.35.193:8080/app/opco/v1/service
         */
        this.basePath;
        this.signatureKey;
        this.clientId;
        this.apiKey;
        this.clientApiKey;
        this.liveMode;
        
        this.coPublicKey;
        this.clientPrivateKey;
        this.clientPrivateKeyPassword;
        this.coTLSCertificate;
        this.idempotentRequestKey;
        this.properties = null;

        /*

        try{
            var props_raw = Checkout.getPropertiesStream();
            if (props_raw != null ){
                //console.log("content from apiclient.js : " + props_raw);
                this.properties = JSON.parse(props_raw);

            }

            else {
                var path = Checkout.getPropertiesFilePath();
                console.log("Properties file path:" + path);
                if (path == null || path == "" || path == 'undefined') {
                    console.log("Properties file path not set. Reading from class path");
                    path = './orbipay_checkout_config.json';
                }
                this.rawdata = fs.readFileSync(path);
                this.properties = JSON.parse(this.rawdata);
            }
            
        }catch(err){
            try{
                console.log("Properties file or filestream not found. Reading from env variable");
                var path = process.env.orbipay_checkout_config;
                this.rawdata = fs.readFileSync(path);
            	this.properties = JSON.parse(this.rawdata);
            	
            }catch(err){
                throw new Error("Can't find orbipay_checkout_config path in system env either.");


            }
        }


        console.log("Properties:");
        console.log(this.properties);

        */

        this.sslSignAlgo = "RSA-SHA256";
        this.hashAlgo = "sha256";

        /**
         * The authentication methods to be included for all API calls.
         * @type {Array.<String>}
         */
        this.authentications = {
            'ApiKeyAuth': {type: 'apiKey', 'in': 'header', name: 'Authorization'}
        };
        /**
         * The default HTTP headers to be included for all API calls.
         * @type {Array.<String>}
         * @default {}
         */
        this.defaultHeaders = {};

        /**
         * The default HTTP timeout for all API calls.
         * @type {Number}
         * @default 60000
         */
        this.timeout = 60000;

        /**
         * If set to false an additional timestamp parameter is added to all API GET calls to
         * prevent browser caching
         * @type {Boolean}
         * @default true
         */
        this.cache = true;

        /**
         * If set to true, the client will save the cookies from each server
         * response, and return them in the next request.
         * @default false
         */
        this.enableCookies = false;

      /*
       * Used to save and return cookies in a node.js (non-browser) setting,
       * if this.enableCookies is set to true.
       */
        if (typeof window === 'undefined') {
            this.agent = new superagent.agent();
        }

    };


    const convertBase64ToPem = function(base64Text, strType) {

    //console.log('in  convertBase64ToPem: ' + base64Text + ' \n ' + strType);
    let str = base64Text;
    //console.log('str length:' + str.length);
    let finalstr = '-----BEGIN ' + strType + '-----\n';
    let cnt = 0;
    for (let i = 0; i < str.length; i += 64) {
        cnt++;
        //console.log('iter and str length  ' + cnt + '  ' + str.length);
        finalstr += str.substr(i, 64) + "\n";
    }

    finalstr += '-----END ' + strType + '-----';
    //console.log("\n\n-------");
    //console.log(finalstr)
    return finalstr.trim();
   };

    //Constants
        var APICONSTANTS = {
                OPAY1_AUTHORIZATION_SCHEME: "OPAY1-HMAC-SHA256",
                LIVE_MODE_TRUE: "true",
                LIVE_MODE_FALSE: "false",
                LIVE_MODE_DEVITG: "devitg",
                LIVE_MODE_QA: "qa",
                LIVE_MODE_LOCAL: "local",
                SANDBOX_API_SERVICE_URL: "https://sbapico.billerpayments.com/app/opco/v5/service",
                PRODUCTION_API_SERVICE_URL: "https://apico.billerpayments.com/app/opco/v5/service",
                LOCAL_API_SERVICE_URL: "http://127.0.0.1:15443/app/opco/v5/service",
                DEVITG_API_SERVICE_URL: "https://devitgapico.billerpayments.com/app/opco/v5/service",
                QA_API_SERVICE_URL: "https://qaapico.billerpayments.com/app/opco/v5/service",
                CHECKOUT_PUBLIC_KEY_LOCATION: "CHECKOUT_PUBLIC_KEY_LOCATION",
                CLIENT_PRIVATE_KEY_LOCATION: "CLIENT_PRIVATE_KEY_LOCATION",
                CLIENT_PRIVATE_KEY_PASSWORD: "CLIENT_PRIVATE_KEY_PASSWORD",
                CHECKOUT_TLS_CERTIFICATE_LOCATION: "CHECKOUT_TLS_CERTIFICATE_LOCATION",
                LIVE_MODE: "LIVE_MODE",
                CLIENT_API_KEY: "CLIENT_API_KEY",
                CHECKOUT_API_SERVICE_URL: "CHECKOUT_API_SERVICE_URL"
        }




    exports.prototype.encryptStringWithRsaPublicKey = function(toEncrypt) {
        console.log("In encrypt method");
        const pemPublicKey = forge.util.decode64(this.coPublicKey);
        const publicKey = forge.pki.publicKeyFromPem(pemPublicKey);
        const encryptedDataBytes = publicKey.encrypt(toEncrypt,'RSA-OAEP',{
            md: forge.md.sha256.create(),
            mgf1: {
              md: forge.md.sha1.create()
            }
        });
        console.log("Encrypted data : "+forge.util.encode64(encryptedDataBytes));
        return forge.util.encode64(encryptedDataBytes);
    };

    exports.prototype.decryptStringWithRsaPrivateKey = function(toDecrypt) {
        const pemPrivateKey = forge.util.decode64(this.clientPrivateKey);
        const encryptedBytes = forge.util.decode64(toDecrypt);
        const privateKey = forge.pki.privateKeyFromPem(pemPrivateKey);
        const decryptData = privateKey.decrypt(encryptedBytes, 'RSA-OAEP', {
            md: forge.md.sha256.create(),
            mgf1: {
              md: forge.md.sha1.create()
            }
          });
        console.log("decrypted data:"+decryptData.toString("utf8"));
        return decryptData.toString("utf8");
    };

    exports.prototype.digiSignWithPrivateKey = function(toSign){
        try{
            //var privateKey = convertBase64ToPem(this.clientPrivateKey, 'PRIVATE KEY');
            var privateKey = new Buffer(this.clientPrivateKey, 'base64');
            console.log("Loaded Priv key for sign ");
        }catch(err){
            throw new Error("Could not find client private key.");
        }
        console.log("In signature generation");
        var signer = crypto.createSign(this.sslSignAlgo);
        signer.update(toSign);
        var sign = signer.sign({key:privateKey,padding:crypto.constants.RSA_PKCS1_PADDING},'base64');
        return sign.toString("utf8");
    };

    exports.prototype.verifyDigiSignWithPublicKey = function(sign,toVerify){
        console.log("In verify sign");
        try{
            //var orbipayPubKey = convertBase64ToPem(this.coPublicKey, 'PUBLIC KEY');
            var orbipayPubKey = new Buffer(this.coPublicKey, 'base64');
            //console.log("orbipayPubKey: \n" + orbipayPubKey);
            console.log("Loaded Pub key for verifying");
        }catch(err){
            throw new Error("Could not find checkout public key.");
        }
        var verifier = crypto.createVerify(this.sslSignAlgo);
        verifier.update(toVerify);
        return verifier.verify(orbipayPubKey, sign,'base64');
    };

    exports.prototype.generateHmacHash = function(key, text){
        var hash = crypto.createHmac(this.hashAlgo, key).update(text).digest('base64');
        return hash;
    };

    exports.prototype.getString = function(params){
        var paramString = "";
        var sortedNames = new Array();
        var index = 0;
        for (var key in params) {
            if (params.hasOwnProperty(key) && params[key] != undefined && params[key] != null) {
                sortedNames[index] = key;    
            }
            index++;
        }
        sortedNames.sort();
        for (var i = 0; i < sortedNames.length; i++) {
            paramString = paramString + (sortedNames[i] + "=" + params[sortedNames[i]]);
            if(i != sortedNames.length -1){
                paramString = paramString + "&";
            }
        }
        return paramString;
    };
    exports.prototype.getHeaderString = function(params){
        var paramString = "";
        var sortedNames = new Array();
        var index = 0;
        for (var key in params) {
            if (params.hasOwnProperty(key) && params[key] != undefined && params[key] != null) {
                sortedNames[index] = key;
            }
            index++;
        }
        sortedNames.sort();
        for (var i = 0; i < sortedNames.length; i++) {
            paramString = paramString+(sortedNames[i] + "=" + params[sortedNames[i]]);
            if(i != sortedNames.length -1){
                paramString = paramString + "&";
            }
        }
        return paramString;
    };

    exports.prototype.computeHMACSHA256Hash = function(url, method, queryParams, headerParams, body, signatureKey){
        var textToHash = "";
        url = url.substr(url.indexOf("/app"));
        url = decodeURIComponent(url);
        textToHash = textToHash + method.toUpperCase() + ":";
        textToHash = textToHash + url + ":";
        textToHash = textToHash + this.getString(queryParams) + ":";
        textToHash = textToHash + this.getHeaderString(headerParams) + ":";
        if(!this.isEmptyObject(body))
        {
            textToHash = textToHash + JSON.stringify(body);
        }
       return this.generateHmacHash(signatureKey, textToHash).trim();
    };

    exports.prototype.getProperty = function(propertyName) {
        var value =  this.properties[propertyName];
        if(value){
            return value;
        }else{
            throw new Error("Can't find property - " + propertyName +". Please provide it in orbipay_checkout_config");
        }
    };

    exports.prototype.checkProperty = function(propertyName) {
        var value =  this.properties[propertyName];
        if(value){
            return true;
        }else{
            return false;
            //throw new Error("Can't find property - " + propertyName +". Please provide it in orbipay_checkout_config");
        }
    };

    exports.prototype.isEmptyObject = function(obj) {
        for (var key in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, key)) {
                return false;
            }
        }
        return true;
    }



    /**
     * Returns a string representation for an actual parameter.
     * @param param The actual parameter.
     * @returns {String} The string representation of <code>param</code>.
     */
    exports.prototype.paramToString = function(param) {
        if (param == undefined || param == null) {
            return '';
        }
        if (param instanceof Date) {
            return param.toJSON();
        }
        return param.toString();
    };

    /**
     * Builds full URL by appending the given path to the base URL and replacing path parameter place-holders with parameter values.
     * NOTE: query parameters are not handled here.
     * @param {String} path The path to append to the base URL.
     * @param {Object} pathParams The parameter values to append.
     * @returns {String} The encoded path with parameter values substituted.
     */
    exports.prototype.buildUrl = function(path, pathParams) {
        if (!path.match(/^\//)) {
            path = '/' + path;
        }
        var url = this.basePath + path;
        var _this = this;
        url = url.replace(/\{([\w-]+)\}/g, function(fullMatch, key) {
            var value;
            if (pathParams.hasOwnProperty(key)) {
                value = _this.paramToString(pathParams[key]);
            } else {
                value = fullMatch;
            }
            return encodeURIComponent(value);
        });
        return url;
    };

    /**
     * Checks whether the given content type represents JSON.<br>
     * JSON content type examples:<br>
     * <ul>
     * <li>application/json</li>
     * <li>application/json; charset=UTF8</li>
     * <li>APPLICATION/JSON</li>
     * </ul>
     * @param {String} contentType The MIME content type to check.
     * @returns {Boolean} <code>true</code> if <code>contentType</code> represents JSON, otherwise <code>false</code>.
     */
    exports.prototype.isJsonMime = function(contentType) {
        return Boolean(contentType != null && contentType.match(/^application\/json(;.*)?$/i));
    };

    /**
     * Chooses a content type from the given array, with JSON preferred; i.e. return JSON if included, otherwise return the first.
     * @param {Array.<String>} contentTypes
     * @returns {String} The chosen content type, preferring JSON.
     */
    exports.prototype.jsonPreferredMime = function(contentTypes) {
        for (var i = 0; i < contentTypes.length; i++) {
            if (this.isJsonMime(contentTypes[i])) {
                return contentTypes[i];
            }
        }
        return contentTypes[0];
    };

    /**
     * Checks whether the given parameter value represents file-like content.
     * @param param The parameter to check.
     * @returns {Boolean} <code>true</code> if <code>param</code> represents a file.
     */
    exports.prototype.isFileParam = function(param) {
        // fs.ReadStream in Node.js and Electron (but not in runtime like browserify)
        if (typeof require === 'function') {
            var fs;
            try {
                fs = require('fs');
            } catch (err) {}
            if (fs && fs.ReadStream && param instanceof fs.ReadStream) {
                return true;
            }
        }
        // Buffer in Node.js
        if (typeof Buffer === 'function' && param instanceof Buffer) {
            return true;
        }
        // Blob in browser
        if (typeof Blob === 'function' && param instanceof Blob) {
            return true;
        }
        // File in browser (it seems File object is also instance of Blob, but keep this for safe)
        if (typeof File === 'function' && param instanceof File) {
            return true;
        }
        return false;
    };

    /**
     * Normalizes parameter values:
     * <ul>
     * <li>remove nils</li>
     * <li>keep files and arrays</li>
     * <li>format to string with `paramToString` for other cases</li>
     * </ul>
     * @param {Object.<String, Object>} params The parameters as object properties.
     * @returns {Object.<String, Object>} normalized parameters.
     */
    exports.prototype.normalizeParams = function(params) {
        var newParams = {};
        for (var key in params) {
            if (params.hasOwnProperty(key) && params[key] != undefined && params[key] != null) {
                var value = params[key];
                if (this.isFileParam(value) || Array.isArray(value)) {
                    newParams[key] = value;
                } else {
                    newParams[key] = this.paramToString(value);
                }
            }
        }
        return newParams;
    };

    /**
     * Enumeration of collection format separator strategies.
     * @enum {String}
     * @readonly
     */
    exports.CollectionFormatEnum = {
        /**
         * Comma-separated values. Value: <code>csv</code>
         * @const
         */
        CSV: ',',
        /**
         * Space-separated values. Value: <code>ssv</code>
         * @const
         */
        SSV: ' ',
        /**
         * Tab-separated values. Value: <code>tsv</code>
         * @const
         */
        TSV: '\t',
        /**
         * Pipe(|)-separated values. Value: <code>pipes</code>
         * @const
         */
        PIPES: '|',
        /**
         * Native array. Value: <code>multi</code>
         * @const
         */
        MULTI: 'multi'
    };

    /**
     * Builds a string representation of an array-type actual parameter, according to the given collection format.
     * @param {Array} param An array parameter.
     * @param {module:ApiClient.CollectionFormatEnum} collectionFormat The array element separator strategy.
     * @returns {String|Array} A string representation of the supplied collection, using the specified delimiter. Returns
     * <code>param</code> as is if <code>collectionFormat</code> is <code>multi</code>.
     */
    exports.prototype.buildCollectionParam = function buildCollectionParam(param, collectionFormat) {
        if (param == null) {
            return null;
        }
        switch (collectionFormat) {
            case 'csv':
                return param.map(this.paramToString).join(',');
            case 'ssv':
                return param.map(this.paramToString).join(' ');
            case 'tsv':
                return param.map(this.paramToString).join('\t');
            case 'pipes':
                return param.map(this.paramToString).join('|');
            case 'multi':
                // return the array directly as SuperAgent will handle it as expected
                return param.map(this.paramToString);
            default:
                throw new Error('Unknown collection format: ' + collectionFormat);
        }
    };

    /**
     * Applies authentication headers to the request.
     * @param {Object} request The request object created by a <code>superagent()</code> call.
     * @param {Array.<String>} authNames An array of authentication method names.
     */
    exports.prototype.applyAuthToRequest = function(request, authNames) {
        var _this = this;
        authNames.forEach(function(authName) {
            var auth = _this.authentications[authName];
            switch (auth.type) {
                case 'basic':
                    if (auth.username || auth.password) {
                        request.auth(auth.username || '', auth.password || '');
                    }
                    break;
                case 'apiKey':
                    if (auth.apiKey) {
                        var data = {};
                        if (auth.apiKeyPrefix) {
                            data[auth.name] = auth.apiKeyPrefix + ' ' + auth.apiKey;
                        } else {
                            data[auth.name] = auth.apiKey;
                        }
                        if (auth['in'] === 'header') {
                            request.set(data);
                        } else {
                            request.query(data);
                        }
                    }
                    break;
                case 'oauth2':
                    if (auth.accessToken) {
                        request.set({'Authorization': 'Bearer ' + auth.accessToken});
                    }
                    break;
                default:
                    throw new Error('Unknown authentication type: ' + auth.type);
            }
        });
    };

    /**
     * Deserializes an HTTP response body into a value of the specified type.
     * @param {Object} response A SuperAgent response object.
     * @param {(String|Array.<String>|Object.<String, Object>|Function)} returnType The type to return. Pass a string for simple types
     * or the constructor function for a complex type. Pass an array containing the type name to return an array of that type. To
     * return an object, pass an object with one property whose name is the key type and whose value is the corresponding value type:
     * all properties on <code>data<code> will be converted to this type.
     * @returns A value of the specified type.
     */
    exports.prototype.deserialize = function deserialize(response, returnType) {
        if (response == null || returnType == null || response.status == 204) {
            return null;
        }
        // Rely on SuperAgent for parsing response body.
        // See http://visionmedia.github.io/superagent/#parsing-response-bodies
        var data = response.body;
        if (data == null || (typeof data === 'object' && typeof data.length === 'undefined' && !Object.keys(data).length)) {
            // SuperAgent does not always produce a body; use the unparsed response as a fallback
            data = response.text;
        }
        return exports.convertToType(data, returnType);
    };

    exports.prototype.deserializeHeader = function deserializeHeader(response, returnType) {
        console.log("inside desheader");
        return exports.convertToType(data, returnType);

    };

    function jsonConcat(o1, o2) {
        for (var key in o2) {
        o1[key] = o2[key];
            }
        return o1;
    }

    function wrapResponseHeader(response){
                var response_header = null;
                if(response.headers["client_key"] != null){
                    var client_key = response.headers["client_key"];
                }
                if(response.headers["request_uuid"] != null){
                    var request_uuid = response.headers["request_uuid"]
                }
                if(response.headers["request_timestamp"] != null){
                    var request_timestamp = response.headers["request_timestamp"];
                }
                if(response.headers["idempotent_request_key"] != null){
                    var idempotent_request_key = response.headers["idempotent_request_key"];
                }
                if(response.headers["response_code"] != null){
                    var response_code = response.headers["response_code"];
                }
                

                response_header = {
                    "client_key": client_key,
                    "request_uuid": request_uuid,
                    "request_timestamp": request_timestamp,
                    "idempotent_request_key": idempotent_request_key,
                    "response_code": response_code
                    };
                return response_header;    

    }

    /**
     * Callback function to receive the result of the operation.
     * @callback module:ApiClient~callApiCallback
     * @param {String} error Error message, if any.
     * @param data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Invokes the REST service using the supplied settings and parameters.
     * @param {String} path The base URL to invoke.
     * @param {String} httpMethod The HTTP method to use.
     * @param {Object.<String, String>} pathParams A map of path parameters and their values.
     * @param {Object.<String, Object>} queryParams A map of query parameters and their values.
     * @param {Object.<String, Object>} headerParams A map of header parameters and their values.
     * @param {Object.<String, Object>} formParams A map of form parameters and their values.
     * @param {Object} bodyParam The value to pass as the request body.
     * @param {Array.<String>} authNames An array of authentication type names.
     * @param {Array.<String>} contentTypes An array of request MIME types.
     * @param {Array.<String>} accepts An array of acceptable response MIME types.
     * @param {(String|Array|ObjectFunction)} returnType The required type to return; can be a string for simple types or the
     * constructor for a complex type.
     * @param {module:ApiClient~callApiCallback} callback The callback function.
     * @returns {Object} The SuperAgent request object.
     */
    exports.prototype.callApi = function callApi(path, httpMethod, pathParams,
                                                 queryParams, headerParams, formParams, bodyParam, authNames, contentTypes, accepts,
                                                 returnType,errorReturntype, callback) {
        var _this = this;

        if(typeof this.liveMode !== 'undefined'){
            if(!(this.liveMode === null)){
              console.log("Live mode value received: " + this.liveMode);
              if(this.liveMode.localeCompare(APICONSTANTS.LIVE_MODE_TRUE, undefined, { sensitivity: 'base' }) === 0){
                  console.log("live mode is true, setting production service url");
                  this.basePath = APICONSTANTS.PRODUCTION_API_SERVICE_URL.replace(/\/+$/, '');
                }else if(this.liveMode.localeCompare(APICONSTANTS.LIVE_MODE_FALSE, undefined, { sensitivity: 'base' }) === 0){
                  console.log("live mode is false, setting sandbox service url");
                  this.basePath = APICONSTANTS.SANDBOX_API_SERVICE_URL.replace(/\/+$/, '');
                }else if(this.liveMode.localeCompare(APICONSTANTS.LIVE_MODE_LOCAL, undefined, { sensitivity: 'base' }) === 0){
                  console.log("live mode is local, setting local service url");
                  this.basePath = APICONSTANTS.LOCAL_API_SERVICE_URL.replace(/\/+$/, '');
                }else if(this.liveMode.localeCompare(APICONSTANTS.LIVE_MODE_DEVITG, undefined, { sensitivity: 'base' }) === 0){
                  console.log("live mode is devitg, setting devitg service url");
                  this.basePath = APICONSTANTS.DEVITG_API_SERVICE_URL.replace(/\/+$/, '');
                }else if(this.liveMode.localeCompare(APICONSTANTS.LIVE_MODE_QA, undefined, { sensitivity: 'base' }) === 0){
                  console.log("live mode is qa, setting qa service url");
                  this.basePath = APICONSTANTS.QA_API_SERVICE_URL.replace(/\/+$/, '');
                }
                else{
                    throw new Error("Invalid configuration of live mode");
                }
          }
        }
        else{
            console.log("Live mode value is not received, reading service url from conf file");
            this.basePath = this.getProperty(APICONSTANTS.CHECKOUT_API_SERVICE_URL).replace(/\/+$/, '');
        }

        
        //this.coTLSCertificate = this.getProperty(APICONSTANTS.CHECKOUT_TLS_CERTIFICATE_LOCATION);


        if(typeof this.clientApiKey !== 'undefined'){
            if(!(this.clientApiKey === null)) {
              console.log("client Api key received");
            }
        }
        else{
            console.log("client api key is not received, setting clientId as clientApiKey");
            this.clientApiKey = this.clientId;
        }

        //var cert = new Buffer(this.coTLSCertificate, 'base64');
        //var cert = convertBase64ToPem(this.coTLSCertificate, 'CERTIFICATE');
        //console.log("Certificate : " + cert)
        console.log("loaded certificate");
        var url = this.buildUrl(path, pathParams);
        var clientHash = this.computeHMACSHA256Hash(url, httpMethod, queryParams, headerParams, bodyParam, this.signatureKey);
        var request = superagent(httpMethod, url);
        // apply authentications
        this.applyAuthToRequest(request, authNames);

        // set query parameters
        if (httpMethod.toUpperCase() === 'GET' && this.cache === false) {
            queryParams['_'] = new Date().getTime();
        }
        request.query(this.normalizeParams(queryParams));

        // set header parameters
        request.set(this.defaultHeaders).set(this.normalizeParams(headerParams));
        request.set("Authorization", "OPAY1-HMAC-SHA256 Credential=" + this.clientApiKey + ",Signature=" + clientHash.trim() + "");
        console.log("idempotentRequestKey : " + this.idempotentRequestKey);
        request.set("idempotent-request-key", this.idempotentRequestKey);
        request.set("User-Agent","checkout-node-sdk-v5-5.4.0");
        // set request timeout
        request.timeout(this.timeout);
        var contentType = this.jsonPreferredMime(contentTypes);
        if (contentType) {
            // Issue with superagent and multipart/form-data (https://github.com/visionmedia/superagent/issues/746)
            if(contentType != 'multipart/form-data') {
                request.type(contentType);
            }
        } else if (!request.header['Content-Type']) {
            request.type('application/json');
        }

        if (contentType === 'application/x-www-form-urlencoded') {
            request.send(querystring.stringify(this.normalizeParams(formParams)));
        } else if (contentType == 'multipart/form-data') {
            var _formParams = this.normalizeParams(formParams);
            for (var key in _formParams) {
                if (_formParams.hasOwnProperty(key)) {
                    if (this.isFileParam(_formParams[key])) {
                        // file field
                        request.attach(key, _formParams[key]);
                    } else {
                        request.field(key, _formParams[key]);
                    }
                }
            }
        } else if (bodyParam) {
            request.send(bodyParam);
        }

        var accept = this.jsonPreferredMime(accepts);
        if (accept) {
            request.accept(accept);
        }

        if (returnType === 'Blob') {
            request.responseType('blob');
        } else if (returnType === 'String') {
            request.responseType('string');
        }

        // Attach previously saved cookies, if enabled
        if (this.enableCookies){
            if (typeof window === 'undefined') {
                this.agent.attachCookies(request);
            }
            else {
                request.withCredentials();
            }
        }

       // request.cert(cert);


        request.end(function(error, response) {
            if (callback) {
                var data = null;
                var response_header = null;
                if (!error) {
                    try {
                        data = _this.deserialize(response, returnType);
                        if (_this.enableCookies && typeof window === 'undefined'){
                            _this.agent.saveCookies(response);
                        }
                        if(response.headers != null){
                            response_header = wrapResponseHeader(response);
                        }
                    } catch (err) {
                        error = err;
                    }
                } else{
                    try {
                        error = _this.deserialize(response, errorReturntype);
                        if (_this.enableCookies && typeof window === 'undefined'){
                            _this.agent.saveCookies(response);
                        }
                        if(response.headers != null){
                            response_header = wrapResponseHeader(response);
                        }
                    } catch (err) {
                        error = err;
                    }
                }
                
                callback(error, data, response_header, response);
            }
        });

        return request;
    };

    /**
     * Parses an ISO-8601 string representation of a date value.
     * @param {String} str The date value as a string.
     * @returns {Date} The parsed date object.
     */
    exports.parseDate = function(str) {
        return new Date(str.replace(/T/i, ' '));
    };

    /**
     * Converts a value to the specified type.
     * @param {(String|Object)} data The data to convert, as a string or object.
     * @param {(String|Array.<String>|Object.<String, Object>|Function)} type The type to return. Pass a string for simple types
     * or the constructor function for a complex type. Pass an array containing the type name to return an array of that type. To
     * return an object, pass an object with one property whose name is the key type and whose value is the corresponding value type:
     * all properties on <code>data<code> will be converted to this type.
     * @returns An instance of the specified type or null or undefined if data is null or undefined.
     */
    exports.convertToType = function(data, type) {
        if (data === null || data === undefined)
            return data

        switch (type) {
            case 'Boolean':
                return Boolean(data);
            case 'Integer':
                return parseInt(data, 10);
            case 'Number':
                return parseFloat(data);
            case 'String':
                return String(data);
            case 'Date':
                return this.parseDate(String(data));
            case 'Blob':
                return data;
            default:
                if (type === Object) {
                    // generic object, return directly
                    return data;
                } else if (typeof type === 'function') {
                    // for model type like: User
                    return type.constructFromObject(data);
                } else if (Array.isArray(type)) {
                    // for array type like: ['String']
                    var itemType = type[0];
                    return data.map(function(item) {
                        return exports.convertToType(item, itemType);
                    });
                } else if (typeof type === 'object') {
                    // for plain object type like: {'String': 'Integer'}
                    var keyType, valueType;
                    for (var k in type) {
                        if (type.hasOwnProperty(k)) {
                            keyType = k;
                            valueType = type[k];
                            break;
                        }
                    }
                    var result = {};
                    for (var k in data) {
                        if (data.hasOwnProperty(k)) {
                            var key = exports.convertToType(k, keyType);
                            var value = exports.convertToType(data[k], valueType);
                            result[key] = value;
                        }
                    }
                    return result;
                } else {
                    // for unknown type, return the data directly
                    return data;
                }
        }
    };

    /**
     * Constructs a new map or array model from REST data.
     * @param data {Object|Array} The REST data.
     * @param obj {Object|Array} The target object or array.
     */
    exports.constructFromObject = function(data, obj, itemType) {
        if (Array.isArray(data)) {
            for (var i = 0; i < data.length; i++) {
                if (data.hasOwnProperty(i))
                    obj[i] = exports.convertToType(data[i], itemType);
            }
        } else {
            for (var k in data) {
                if (data.hasOwnProperty(k))
                    obj[k] = exports.convertToType(data[k], itemType);
            }
        }
    };

    /**
     * The default API client implementation.
     * @type {module:ApiClient}
     */
    // exports.instance = new exports();

    return exports;
}));
