/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address', 'model/PaymentVO', 'model/ConfirmPaymentTokenRequest', 'model/CustomerAccount', 'model/Payer', 'model/Error', 'model/ErrorsResponse', 'model/FundingAccount', 'api/Payment', 'api/PaymentTokenApi', 'api/FundingAccountApi', 'api/FundingAccountTokenApi', 'model/ConfirmAddFundAcctResponse', 'model/PaymentToken', 'model/FundingAccountToken','model/ConfirmAddFundAccTokenRequest', 'model/Fee', 'model/Customer', 'model/PaymentNetworkResponse', 'api/InvocationContext', 'model/ResponseHeader', "Checkout"], factory);  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('./ApiClient'), require('./model/Address'), require('./model/PaymentVO'), require('./model/ConfirmPaymentTokenRequest'), require('./model/CustomerAccount'), require('./model/Payer'), require('./model/Error'), require('./model/ErrorsResponse'), require('./model/FundingAccount'), require('./api/Payment'), require('./api/PaymentTokenApi'), require('./model/ConfirmAddFundAcctResponse'), require('./api/FundingAccountApi'), require('./api/FundingAccountTokenApi'), require('./model/PaymentToken'), require('./model/FundingAccountToken'), require('./model/ConfirmAddFundAccTokenRequest'), require('./model/Fee'), require('./model/PaymentNetworkResponse'), require('./model/Customer'), require('./api/InvocationContext'), require('./model/ResponseHeader'), require('./Checkout'));
  }
}(this, function(ApiClient, Address, PaymentVO, ConfirmPaymentTokenRequest, CustomerAccount, Payer, Error, ErrorsResponse, FundingAccount, Payment, PaymentTokenApi, ConfirmAddFundAcctResponse, FundingAccountApi, FundingAccountTokenApi, PaymentToken, FundingAccountToken, ConfirmAddFundAccTokenRequest, Fee, PaymentNetworkResponse, Customer, InvocationContext, ResponseHeader, Checkout) {
  'use strict';

  /**
   * API_specification_to_use_the_Orbipay_Checkout_APIs__This_documentation_covers_the_Merchant_Account_Management_and_Charge_Management_related_APIs__.<br>
   * The <code>index</code> module provides access to constructors for all the classes which comprise the public API.
   * <p>
   * An AMD (recommended!) or CommonJS application will generally do something equivalent to the following:
   * <pre>
   * var OrbipayCheckoutApIs = require('index'); // See note below*.
   * var xxxSvc = new OrbipayCheckoutApIs.XxxApi(); // Allocate the API class we're going to use.
   * var yyyModel = new OrbipayCheckoutApIs.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * <em>*NOTE: For a top-level AMD script, use require(['index'], function(){...})
   * and put the application logic within the callback function.</em>
   * </p>
   * <p>
   * A non-AMD browser application (discouraged) might do something like this:
   * <pre>
   * var xxxSvc = new OrbipayCheckoutApIs.XxxApi(); // Allocate the API class we're going to use.
   * var yyy = new OrbipayCheckoutApIs.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * </p>
   * @module index
   * @version 1.0.0
   */
  var exports = {
    /**
     * The ApiClient constructor.
     * @property {module:ApiClient}
     */
    ApiClient: ApiClient,

    PaymentTokenApi: PaymentTokenApi,

    FundingAccountTokenApi: FundingAccountTokenApi,

    ConfirmAddFundAcctResponse: ConfirmAddFundAcctResponse,

   

    /**
     * The Address model constructor.
     * @property {module:model/Address}
     */
    Address: Address,
    /**
     * The PaymentVO model constructor.
     * @property {module:model/PaymentVO}
     */
    PaymentVO: PaymentVO,
    /**
     * The ConfirmPaymentTokenRequest model constructor.
     * @property {module:model/ConfirmPaymentTokenRequest}
     */
    ConfirmPaymentTokenRequest: ConfirmPaymentTokenRequest,
    /**
     * The CustomerAccount model constructor.
     * @property {module:model/CustomerAccount}
     */
    CustomerAccount: CustomerAccount,
    /**
     * The Payer model constructor.
     * @property {module:model/Payer}
     */
    Payer: Payer,
    /**
     * The Error model constructor.
     * @property {module:model/Error}
     */
    Error: Error,
    /**
     * The ErrorsResponse model constructor.
     * @property {module:model/ErrorsResponse}
     */
    ErrorsResponse: ErrorsResponse,
    /**
     * The FundingAccount model constructor.
     * @property {module:model/FundingAccount}
     */
    FundingAccount: FundingAccount,
 
    /**
     * The Payment service constructor.
     * @property {module:api/Payment}
     */
    Payment: Payment, 
    /**
    * The Payment service constructor.
    * @property {module:model/PaymentToken}
    */
   PaymentToken: PaymentToken,

  /**
    * The Payment service constructor.
    * @property {module:model/FundingAccountToken}
    */
   FundingAccountToken: FundingAccountToken,
    /**
    * The Payment service constructor.
    * @property {module:model/ConfirmAddFundAccTokenRequest}
    */
   ConfirmAddFundAccTokenRequest: ConfirmAddFundAccTokenRequest,
    /**
    * The Payment service constructor.
    * @property {module:model/Fee}
    */
   Fee: Fee,
   PaymentNetworkResponse: PaymentNetworkResponse,
   InvocationContext: InvocationContext,
   /**
    * The Payment service constructor.
    * @property {module:model/Customer}
    */
   Customer: Customer,

   ResponseHeader: ResponseHeader,

   Checkout: Checkout
  };

  return exports;
}));
