/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
    if (typeof define === 'function' && define.amd) {
      // AMD. Register as an anonymous module.
      define(['ApiClient', 'model/PaymentToken'], factory);
    } else if (typeof module === 'object' && module.exports) {
      // CommonJS-like environments that support module.exports, like Node.
      module.exports = factory(require('../ApiClient'), require('./PaymentToken'));
    } else {
      // Browser globals (root is window)
      if (!root.OrbipayCheckoutApIs) {
        root.OrbipayCheckoutApIs = {};
      }
      root.OrbipayCheckoutApIs.ConfirmAddFundAccTokenRequest = factory(root.OrbipayCheckoutApIs.ApiClient, root.OrbipayCheckoutApIs.PaymentToken);
    }
  }(this, function(ApiClient, PaymentToken) {
    'use strict';
  
  
  
  
    /**
     * The ConfirmAddFundAccTokenRequest model module.
     * @module model/ConfirmAddFundAccTokenRequest
     * @version 1.0.0
     */
  
    /**
     * Constructs a new <code>ConfirmAddFundAccTokenRequest</code>.
     * @alias module:model/ConfirmAddFundAccTokenRequest
     * @class
     */
    var exports = function() {
      var _this = this;
  
  
  
    };
  
    /**
     * Constructs a <code>ConfirmAddFundAccTokenRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ConfirmAddFundAccTokenRequest} obj Optional instance to populate.
     * @return {module:model/ConfirmAddFundAccTokenRequest} The populated <code>ConfirmAddFundAccTokenRequest</code> instance.
     */
    exports.constructFromObject = function(data, obj) {
      if (data) {
        obj = obj || new exports();
  
        if (data.hasOwnProperty('funding_account_token')) {
          obj['funding_account_token'] = PaymentToken.constructFromObject(data['funding_account_token']);
        }
      }
      return obj;
    }
  
    /**
     * @member {Object} funding_account_token
     */
    exports.prototype['funding_account_token'] = undefined;
  
  
    return exports;
  }));
  
  
  