/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayCheckoutApIs) {
      root.OrbipayCheckoutApIs = {};
    }
    root.OrbipayCheckoutApIs.CustomerAccount = factory(root.OrbipayCheckoutApIs.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CustomerAccount model module.
   * @module model/CustomerAccount
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>CustomerAccount</code>.
   * @alias module:model/CustomerAccount
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>CustomerAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CustomerAccount} obj Optional instance to populate.
   * @return {module:model/CustomerAccount} The populated <code>CustomerAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('currentBalance')) {
        obj['currentBalance'] = ApiClient.convertToType(data['currentBalance'], 'String');
      }
      if (data.hasOwnProperty('currentStatemenBalance')) {
        obj['currentStatemenBalance'] = ApiClient.convertToType(data['currentStatemenBalance'], 'String');
      }
      if (data.hasOwnProperty('minimumPaymentDue')) {
        obj['minimumPaymentDue'] = ApiClient.convertToType(data['minimumPaymentDue'], 'String');
      }
      if (data.hasOwnProperty('pastAmountDue')) {
        obj['pastAmountDue'] = ApiClient.convertToType(data['pastAmountDue'], 'String');
      }
      if (data.hasOwnProperty('paymentDueDate')) {
        obj['paymentDueDate'] = ApiClient.convertToType(data['paymentDueDate'], 'String');
      }
      if (data.hasOwnProperty('statementDate')) {
        obj['statementDate'] = ApiClient.convertToType(data['statementDate'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('account_id')) {
        obj['account_id'] = ApiClient.convertToType(data['account_id'], 'String');
      }
      if (data.hasOwnProperty('nickname')) {
        obj['nickname'] = ApiClient.convertToType(data['nickname'], 'String');
      }
      if (data.hasOwnProperty('account_number')) {
        obj['account_number'] = ApiClient.convertToType(data['account_number'], 'String');
      }
      if (data.hasOwnProperty('address')) {
        obj['address'] = ApiClient.convertToType(data['address'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('id_account')) {
        obj['id_account'] = ApiClient.convertToType(data['id_account'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['account_holder_name'] = ApiClient.convertToType(data['account_holder_name'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
      }
    }
    return obj;
  }

  /**
   * @member {String} currentBalance
   */
  exports.prototype['currentBalance'] = undefined;
  exports.prototype['currentStatemenBalance'] = undefined;
  exports.prototype['minimumPaymentDue'] = undefined;
  exports.prototype['pastAmountDue'] = undefined;
  exports.prototype['paymentDueDate'] = undefined;
  exports.prototype['statementDate'] = undefined;
  exports.prototype['id'] = undefined;
  exports.prototype['account_id'] = undefined;
  exports.prototype['nickname'] = undefined;
  exports.prototype['account_number'] = undefined;
  exports.prototype['address'] = undefined;
  exports.prototype['status'] = undefined;
  exports.prototype['id_account'] = undefined;
  exports.prototype['account_holder_name'] = undefined;
  exports.prototype['url'] = undefined;
  exports.prototype['custom_fields'] = undefined;
  
  return exports;
}));


