/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
    if (typeof define === 'function' && define.amd) {
      // AMD. Register as an anonymous module.
      define(['ApiClient'], factory);
    } else if (typeof module === 'object' && module.exports) {
      // CommonJS-like environments that support module.exports, like Node.
      module.exports = factory(require('../ApiClient'));
    } else {
      // Browser globals (root is window)
      if (!root.OrbipayCheckoutApIs) {
        root.OrbipayCheckoutApIs = {};
      }
      root.OrbipayCheckoutApIs.ResponseHeader = factory(root.OrbipayCheckoutApIs.ApiClient);
    }
  }(this, function(ApiClient) {
    'use strict';
    
    /**
     * The Fee model module.
     * @module model/Fee
     * @version 1.0.0
     */
  
    /**
     * Constructs a new <code>Fee</code>.
     * @alias module:model/Fee
     * @class
     * @param feeType {String} 
     * @param id {String} 
     * @param url {String}
     * @param feeAmount {String} 
     */
    var exports = function() {
      var _this = this;
    };
  
    /**
     * Constructs a <code>Fee</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Fee} obj Optional instance to populate.
     * @return {module:model/Fee} The populated <code>Fee</code> instance.
     */
    exports.constructFromObject = function(data, obj) {
      if (data) {
        obj = obj || new exports();
  
        if (data.hasOwnProperty('client_key')) {
          obj['client_key'] = ApiClient.convertToType(data['client_key'], 'String');
        }
        if (data.hasOwnProperty('request_uuid')) {
          obj['request_uuid'] = ApiClient.convertToType(data['request_uuid'], 'String');
        }
        if (data.hasOwnProperty('request_timestamp')) {
          obj['request_timestamp'] = ApiClient.convertToType(data['request_timestamp'], 'String');
        }
        if (data.hasOwnProperty('idempotent_request_key')) {
          obj['idempotent_request_key'] = ApiClient.convertToType(data['idempotent_request_key'], 'String');
        }
        if (data.hasOwnProperty('response_code')) {
          obj['response_code'] = ApiClient.convertToType(data['response_code'], 'String');
        }
      }
      return obj;
    }
  

    exports.prototype['client_key'] = undefined;

    exports.prototype['request_uuid'] = undefined;

    exports.prototype['request_timestamp'] = undefined;

    exports.prototype['idempotent_request_key'] = undefined;

    exports.prototype['response_code'] = undefined;

    return exports;

    }));
  
  
  